#ifndef DENSEMATRIX_H
#define    DENSEMATRIX_H 1

class DenseMatrix{
private:
    double ** matrix;
    int M,N;
public:
    
    DenseMatrix(const int n);

    DenseMatrix(const int m, const int n);

    ~DenseMatrix();

    double &
    operator()(const int m, const int n) const;

    int numCols() const;

    int numRows() const;
    

};



DenseMatrix::DenseMatrix(const int n):M(n),N(n){
    matrix = new double*[n];
    for(int i = 0; i < n; ++i){
        matrix[i] = new double[n];
        for(int j = 0; j < n; ++j){
            matrix[i][j] = 0;
        }
    }
}


DenseMatrix::DenseMatrix(const int m, const int n):M(m),N(n){
    matrix = new double*[m];
    for(int i = 0; i < m; ++i){
        matrix[i] = new double[n];
        for(int j = 0; j < n; ++j){
            matrix[i][j] = 0;
        }
    }
}

DenseMatrix::~DenseMatrix(){
    for(int i = 0; i < N; ++i){
        delete [] matrix[i];
    }
    delete [] matrix;
}

double &
DenseMatrix::operator()(const int m, const int n) const{
    return matrix[m][n];
}

int
DenseMatrix::numRows() const{
    return M;
}

int 
DenseMatrix::numCols() const{
    return N;
}

std::ostream& 
operator<< (std::ostream& out, const DenseMatrix & matrix){
    for(int i = 0; i < matrix.numRows(); ++i){
        for(int j = 0; j < matrix.numCols(); ++j){
            out << matrix(i,j) << " ";
        }
        out << std::endl;
    }
    return out;
}





#endif