#ifndef SPARSEMATRIX_H
#define SPARSEMATRIX_H 1

#include <map>
#include <utility>



//bool operator<(const std::pair<int,int> & left, const std::pair<int, int> & right){
//    if(left.first < right.first){
//        return true;
//    } else if(left.first == right.first){
//        if(left.second < right.second){
//            return true;
//        }
//    }
//    return false;
//}


class SparseMatrix{
    
    int M,N;
public:
    std::map<std::pair<int,int>, double> data;
    
    SparseMatrix(const int n);

    SparseMatrix(const int m, const int n);

    double & 
    operator()(int m,int n);

    int numCols() const;

    int numRows() const;

};



SparseMatrix::SparseMatrix(const int n):M(n),N(n){}


SparseMatrix::SparseMatrix(const int m, const int n):M(m),N(n){}



//this operator is used to set the non-zero values in the sparse-matrix
//CAREFUL: Do not try to access matrix positions where the value is zero, since this creates an entry with value zero!
// Then SparseMatrix is not sparse anymore!
double &
SparseMatrix::operator()(int m, int n){ 
    return data[std::pair<int,int>(m,n)];
}


int
SparseMatrix::numRows() const{
    return M;
}

int 
SparseMatrix::numCols() const{
    return N;
}


std::ostream& 
operator<< (std::ostream& out, SparseMatrix & matrix){
    for(std::map<std::pair<int,int>,double>::iterator iterator = matrix.data.begin(); iterator != matrix.data.end(); iterator++) {
        out << "(" << (iterator->first).first << "," << (iterator->first).second << ") => " << iterator->second << std::endl;
    }
    return out;
}

#endif 