#ifndef VECTOR_H
#define VECTOR_H 1



class Vector{
    double * data;
    int N;
public:

    Vector();

    Vector(const int n);

    Vector(const Vector & copy);

    ~Vector();

    double &
    operator[](const int n) const;

    Vector &
    operator=(const Vector & copy);

    int size() const;

};

Vector::Vector():N(1){
    data = new double[1];
    data[0]  = 1.0;
}

Vector::Vector(const int n):N(n){
    data = new double[n];
    for(int i= 0; i < n; ++i){
        data[i] = 0.0;
    }
}

Vector::Vector(const Vector & copy):N(copy.size()){
    data = new double[copy.size()];
    for(int i = 0; i < copy.size(); ++i){
        data[i] = copy[i];
    }
}

Vector::~Vector(){
    delete [] data;
}

double & 
Vector::operator[](const int n) const{
    return data[n];
}


Vector &
Vector::operator=(const Vector & copy){
    delete [] data;
    N = copy.size();
    data = new double[copy.size()];
    for(int i = 0; i < copy.size(); ++i){
        data[i] = copy[i];
    }
    return *this;
}

int 
Vector::size() const{
    return N;
}


std::ostream& 
operator<< (std::ostream& out, const Vector & v){
    for(int i = 0; i < v.size(); ++i){
        out << v[i] << " ";
    }
    
    return out;
}

#endif